
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.lang.*;
import java.util.*;

public class CS extends java.applet.Applet 
  implements  Runnable,ActionListener,MouseListener,MouseMotionListener{
  /* #############################
   *    Caffienated Space
   *    Game code developed by Andrew, Velusip and Alexei
   *    Music ripped from Buzz Music Composer samples
   *    Sound ripped from Continuum
   *    Graphics by Velusip
   *    
   *    December 2001 - January 2002
   * 
   * #############################
   */
  
  //CONST
  final int columns = 15;
  final int rows = 20;
  final int blockwidth = 20;
  final int ship = 1;
  final int laser = 2;
  final int enemy = 3;
  //VARS
  int mouseloc = 100; //keeps track of x coord of mouse
  int shiploc = 8; //ship location ( x coord or column ) monitored
  int laserpending = 0; //how many lasers are going to fire, limits rapid fire
  int heatcounter = 0; //counts laser heat, limits rapid fire
  int lasermonitor = 0; //inverses the loop through the main physics code to accomidate lasers upward path
  int difficulty = 50; //default initial difficulty ( lower=harder )
  int diffcount = 0; //counts up to difficulty then refreshes enemies ( also serves as frame counter )
  int grid[][] = new int[rows][columns]; //the main 2dim grid with all in game objects
  boolean shipmoved = false; //if ship has moved this frame
  //GAME STATS
  Font thefont;
  int lasersfired = 0;
  int enemieskilled = 0;
  int enemiesescaped = 0;
  int enemiesspawned = 0;
  int shotdown = 0;
  int points = 0; //in game points
  int dmg = 0; //damage to ship ( game over when 100 )
  //BOSS VARS
  Thread go; //main game thread
  static boolean playing = false; //defines state of game
  //SOUND
  String auFile0 = "creepy.au"; //the bg music file
  String auFile1 = "gun.au"; //gun sound
  String auFile2 = "explode.au"; //explode sound
  AudioClip loopClip,shootClip,explodeClip; ///*later goes...*/ = getAudioClip(getCodeBase(), auFile0); //get sound file
  boolean looping = false; //if clip playing, looping true
  //IMAGES
  String jpgFile0 = "enemy.jpg";
  String jpgFile1 = "ship.jpg";
  Image baddy;
  Image shippy;
  //BUTTONS
  Button loopButton = new Button("play"); //play music
  Button stopButton = new Button("stop"); //stop music
  Button goButton = new Button("GO");
  Button helpButton = new Button("help");
  Button backButton = new Button("back to main");
  //Intro
  String helpTxt = null;
  TextArea helpText;
  Label nameText = new Label();
  Choice diff;
  //For the stats screen
  TextArea stascr;
  
  public void init(){ //initialize stuff, make stuff, define stuff
    setLayout(null); //NULL BUTTON LAYOUT, DEFINE LATER
    //lOAD SOUNDS
    loopClip = getAudioClip(getDocumentBase(), auFile0); //get music file
    shootClip = getAudioClip(getDocumentBase(), auFile1); //get gun file
    explodeClip = getAudioClip(getDocumentBase(), auFile2); //get explode file
    //lOAD IMAGES
    baddy = getImage(getDocumentBase(),jpgFile0); //get enemy image
    shippy = getImage(getDocumentBase(),jpgFile1); //get ship image
    //MOUSE LISTENERS
    addMouseListener(this);
    addMouseMotionListener(this);
    thefont = new Font("Courier",0, 10); //font
    setBackground(Color.black); //BG color
    //INI BUTTONS
    //LISTEN TO 'EM
    loopButton.addActionListener(this);
    stopButton.addActionListener(this);
    //DEFINE GOOD LOOKS
    goButton.setBounds(10,300,200,90);
    helpButton.setBounds(230,300,200,90);
    backButton.setBounds(10,350,400,40);
    goButton.setBackground(Color.black);
    helpButton.setBackground(Color.black);
    backButton.setBackground(Color.black);
    goButton.setForeground(Color.white);
    helpButton.setForeground(Color.white);
    backButton.setForeground(Color.white);
    goButton.setFont(new Font("Courier",0, 20));
    helpButton.setFont(new Font("Courier",0, 20));
    backButton.setFont(new Font("Courier",0, 15));
    goButton.addActionListener(this);
    helpButton.addActionListener(this);
    backButton.addActionListener(this);
    loopButton.setBounds(columns*blockwidth+10,140,40,20);
    stopButton.setBounds(columns*blockwidth+50,140,40,20);
    stopButton.setBackground(Color.black);
    stopButton.setForeground(Color.white);
    loopButton.setForeground(Color.white);
    loopButton.setBackground(Color.black);
    //ADD INITAL BUTTONS
    add(goButton);
    add(helpButton);
    add(loopButton);
    add(stopButton);
    stopButton.setEnabled(false);
    
    //Help screen text
    helpText = new TextArea();
    helpText.setBounds(10,50,280,300);
    helpTxt = "Welcome to Caffeinated Space!" 
                + "\nIn a universe far, far away..."
                + "\nan evil menace was threating "
                + "\nto destroy the universe...  "
                + "\nHumanities only hope lies in"
                + "\none person...that person is "
                + "\nyou!!!"
                + "\n\nYour mission should you choose"
                + "\nto except it is to expertly fly"
                + "\na top secret weapon A.K.A weapon x"
                + "\nstoping any and all bad as*'s "
                + "\nfrom reaching Earth."
                + "\nAt your disposal is a super deadly"
                + "\nlaser."
                + "\n...........Controls.............."
                + "\nTo move left-move the mouse left"
                + "\nTo move right-move the mouse right"
                + "\nTo fire the laser-press the mouse button"
                + "\n........Good Luck...........";
        
    helpText.setText(helpTxt);
    helpText.setForeground(Color.white);
    helpText.setEditable(false);
    nameText.setFont(new Font("Arial", Font.BOLD,33));
    nameText.setForeground(Color.white);
    nameText.setText("Caffeinated Space");
    nameText.setBounds(8,40,285,50);
    
    stascr = new TextArea();
    stascr.setBounds(10,50,280,300);
    stascr.setText(helpTxt);
    stascr.setForeground(Color.white);
    stascr.setEditable(false);
    add(helpText);
    add(nameText);
    add(stascr);
    helpText.setVisible(false);
    stascr.setVisible(false);
    nameText.setVisible(true);
    //diff
    diff = new Choice();
      diff.add("Private");
      diff.add("Sergent");
      diff.add("Captain");
      diff.add("Cyborg");
      
      diff.setBackground(Color.black);
      diff.setForeground(Color.white);
      diff.select(1);
      diff.setBounds(310,260,70,20);
      add(diff);
      
      
    //thread call for game to start
    //go = new Thread(this);
    }
  
  
  public void run(){
    //INITIALIZE GAME VARS
    difficulty = 20 - (diff.getSelectedIndex()*6);
    points = 0;
    dmg = 0;
    lasersfired = 0;
    enemieskilled = 0;
    enemiesescaped = 0;
    enemiesspawned = 0;
    shotdown = 0;
    shiploc = 8;
    
    
    
    playing = true;
    for(int i = 0; i < rows; i++){
      for(int j = 0; j <columns; j++){
        grid[i][j] = 0;}}
    grid[rows-1][shiploc] = ship;
    
    //MAIN LOOP
    while(playing){
      physics();
      repaint();
      try{Thread.sleep(40);} //tells current thread to wait X ms
      catch(InterruptedException e){} //it could cause a problem if some other thread is mean
      playing = dmg < 100; //max dmg is...
      }
    
    stats();
    
    
    
    }
  
  
  public void stop(){ //executes after you call stop or the applet is stoped by browser
    //depreciated, but it makes older java versions happy.
    loopClip.stop();
    go.stop();
    }
  
  
  
  
  public void actionPerformed(ActionEvent e){//when some button was pressed
    
    if(e.getSource().equals(goButton)){
      remove(goButton);
      remove(helpButton);
      helpText.setVisible(false);
      nameText.setVisible(false);
      stascr.setVisible(false);
      remove(diff);
      go = new Thread(this);
      go.start();
      }
    
    if(e.getSource().equals(helpButton)){
      remove(goButton);
      remove(helpButton);
      remove(diff);
      /* show help screen */
      helpText.setVisible(true);
      nameText.setVisible(false);
      stascr.setVisible(false);
      add(backButton);
      }
    
    if(e.getSource().equals(backButton)){
      add(goButton);
      add(helpButton);
      add(diff);
      go = null;
      /* exit help screen */
      helpText.setVisible(false);
      nameText.setVisible(true);
      stascr.setVisible(false);
      remove(backButton);
      }
    
    
    //SOUND BUTTONS
    ////if START LOOP BUTTON
    if (e.getSource().equals(loopButton)) {
      //loopClip = loopClip.getClip(auFile0); //capture music file?
      looping = true;
      loopClip.loop(); //start the sound loop
      loopButton.setEnabled(false); //disable loop button
      stopButton.setEnabled(true); 
      } //end if loopButton
    
    ////if STOP LOOP BUTTON
      if (e.getSource().equals(stopButton)) {
        if (looping) {
          looping = false;
          loopClip.stop(); //stop the sound loop
          loopButton.setEnabled(true); //enable start button
          }
          stopButton.setEnabled(false);
        } //end if stopButton
    
    
    } //end actionPerformed
  
  

  public void paint(Graphics g) { //paints all objects in grid and hud info
    g.setFont(thefont);
    g.setColor(Color.white);
    g.drawString("Damage     : " + Integer.toString(dmg) + "%",305,45);
    
    for(int i = 0; i < rows  ;i++){
      for(int j = 0; j < columns ;j++){
    	if(grid[i][j] == enemy){
    	  g.setColor(Color.red);
          g.fillOval(blockwidth*j,blockwidth*i,blockwidth,blockwidth); //img substitute
          g.drawImage(baddy,blockwidth*j,blockwidth*i,this); //img of enemy
          }
        if(grid[i][j] == ship){
          g.setColor(Color.blue);
          g.fillOval(blockwidth*j,blockwidth*i,blockwidth,blockwidth); //img substitute
          g.drawImage(shippy,blockwidth*j,blockwidth*i,this); //img of ship
          }
        if(grid[i][j] == laser){
          g.setColor(Color.white);
          g.fillRect(blockwidth*j+9,blockwidth*i,3,blockwidth);
          }
        } //cols
      } //rows
    g.setColor(Color.white);
    g.drawRect(1,1,300,400);
    }
  
  
  
  public void stats() {
    stascr.setText("	   You Lose\n" +
    				"Stopped    : " + Integer.toString(enemieskilled)+"\n"+
    				"Escaped    : " + Integer.toString(enemiesescaped)+"\n"+
    				"Points     : " + Integer.toString(points)+"\n"+
    				"Success    : " + Integer.toString((shotdown/enemiesspawned)*100));
        /* TEMP STATS
    FOR STATS SCREEN
        g.drawString("Stopped    : " + Integer.toString(enemieskilled),305,75);
        g.drawString("Escaped    : " + Integer.toString(enemiesescaped),305,85);
        g.drawString("Points     : " + Integer.toString(points),305,55);
        g.drawString("Success    : " + Integer.toString((shotdown/enemiesspawned)*100) + "%",305,105);
        
    */
     stascr.setVisible(true);
     add(backButton);
    }
  
  
  
  
  public void spawn_enemy() {
    //places enemies in top row of grid
    int rnd = (int) ((Math.random() * 15));
    int rnd0 = (int) ((Math.random() * difficulty));
    if (rnd0 < 10) {grid[0][rnd] = enemy;
      enemiesspawned++;
      }
    }
  public void spawn_laser(int a, int b) {
    //sets grid loc as laser
    grid[a][b] = laser;
    lasersfired++;
    shootClip.play(); //play shootClip
    }
  public void get_point() {
    //adds points to your score
    points+=2;
    }
  public void destruct(int a, int b) {
    //destroys anything at the inputted coords of the grid... mwahahaha!
    grid[a][b] = 0;
    }
  public void damage() {
    //damage points added
    dmg+=10;
    }
  public void move_down(int a, int b) {
    //moves anything at the inputted coords of the grid down one
    //does not check ahead to see what is in space
    grid[a+1][b] = grid[a][b];
    grid[a][b] = 0;
    }
  public void move_up(int a, int b) {
    //moves anything at the inputted coords of the grid up one
    //does not check ahead to see what is in space
    grid[a-1][b] = grid[a][b];
    grid[a][b] = 0;
    }
  public void move_left(int a, int b) {
    //moves anything at the inputted coords of the grid left
    grid[a][b-1] = grid[a][b];
    grid[a][b] = 0;
    }
  public void move_right(int a, int b) {
    //moves anything at the inputted coords of the grid right
    grid[a][b+1] = grid[a][b];
    grid[a][b] = 0;
    }
  
  
  public void update_ship(int a,int b) {
    //moves the ship closer to the mouses location or hit enemy
    if(mouseloc > ((shiploc*blockwidth)+blockwidth)) { //going right
      if(shiploc <= (columns-2)) { //if ship go any further right
        if(grid[a][b+1] == enemy) { //if enemy right
          destruct(a,b+1); //enemy dies
          enemieskilled++;
          damage();
          points-=5;
          explodeClip.play(); //play explode sfx
          } //end if enemy right
        move_right(a,b);
        shiploc = b+1;
        } //end if ship can move right
      } //end if mouse over there
    else if(mouseloc < (shiploc*blockwidth)) {
      if(shiploc >= 1) {
        if(grid[a][b-1] == enemy) { //if enemy left
          destruct(a,b-1); //enemy dies
          enemieskilled++;
	      damage();
	      points-=5;
	      explodeClip.play(); //play explode sfx
          } //end if enemy left
        move_left(a,b);
        shiploc = b-1;
        } //end if ship can move
      } //end if mouse over there
    } //end update_ship
  
  
  
  public void physics() {
    //regulates object positions and interactivity
    diffcount++;
    shipmoved = false; //so that ship does not move /with/ GRID LOOP
    //GRID LOOP
    for(int i = rows-1; i >= 0; i--) {
      for(int j = columns-1; j >= 0; j--) {
        //update ship
        if((grid[i][j] == ship) && (!(shipmoved))) {
          update_ship(i,j);
          shipmoved = true;
          }
        //update laser
        lasermonitor = ((rows-1)-i); //opposite counter to main loop
        if(grid[lasermonitor][j] == laser) { //if found laser
          if(lasermonitor == 0) { //if at top of grid
            destruct(lasermonitor,j);
            } //end if at top
          else if(grid[lasermonitor-1][j] == enemy) { //if enemy right above
            destruct(lasermonitor-1,j);
            enemieskilled++;
            shotdown++;
            destruct(lasermonitor,j);
            get_point();
            } //end if enemy above
          else {
            move_up(lasermonitor,j); //clear sailing
            } //end if none
          }
        //update enemy
        if((diffcount % (difficulty/2)) == 0) { //if time for update enemy location
          //detect enemy collision ( considered asynchronous with move )
          if(grid[i][j] == enemy) { //found enemy
            if(i == (rows-1)) { //found on last row
              destruct(i,j);
              enemiesescaped++;
              points--;
              }
            else if(grid[i+1][j] == ship) { //found ship ahead
              destruct(i,j);
              enemieskilled++;
              damage();
              points-=5;
              explodeClip.play(); //play explode sfx
              }
            else if(grid[i+1][j] == 0) { //nothing ahead
              move_down(i,j); //move the enemy down one
              } //endif enemy adjacency
            } //end found enemy
          } //end if time for update enemy location
        } //end for columns
      } //end for rows
    
    //time to make some more enemies
    if((diffcount % difficulty) == 1) spawn_enemy();
    //time to update the laser
    if(laserpending > 0) {
      if(heatcounter > 0) { //heat
        heatcounter--; //deplete heat
        } //end if heat
      else if(heatcounter == 0) {
        laserpending--; //reduce lasers
        spawn_laser(rows-2,shiploc);
        } //end if no heat
      } //end laser pending
    
    
    } //end physics



  public void mousePressed(MouseEvent e) {} //when press
  public void mouseReleased(MouseEvent e) {} //after release
  public void mouseClicked(MouseEvent e) {
    //after release if was fast enough
    if(playing) { //game is go
      if(heatcounter == 0) { //no heat
        laserpending++; //laser prepared for fire
        if(laserpending > 5) { //if too many ready to fire
          laserpending = 0; //lose pending lasers
          heatcounter = 20; //heat counter disables fire for X frames
          } //end too many lasers
        } //end if no heat
      } //end if playing
    } //end mouseClicked
  
  public void mouseEntered(MouseEvent e) {} //entered the listening component
  public void mouseExited(MouseEvent e) {} //leaves the listening component enters another component
  public void mouseDragged(MouseEvent e) {mouseloc = e.getX();} //mousemotionlistener moved while pressed
  public void mouseMoved(MouseEvent e) {mouseloc = e.getX();} //moved while not pressed
  } //end class
